﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace ThreadSynchronization
{
    class Program
    {
        /*
         * Aplikace vypisuje pomoci dvou vlaken do konzole zluta pismena X a cervena pismena O.
         * 
         * Pokud by nebyl pristup synchronizovan pomoci konstrukce lock, vlakna 
         * by souperila o nastaveni barvy konzole a doslo by k vypisovani ruznych kombinaci.
         * 
         * Blok lock ridi vstup podle predaneho objektu ktery slouzi jako zamek. 
         * Pri vstupu libovolneho vlakna do bloku lock se prislusny zamek zamkne 
         * a zadne jine vlakno nemuze vstoupit do zadneho bloku lock pouzivajici
         * stejny zamek. 
         * 
         * Jestlize program nemuze vstoupit do bloku lock, zastavi se a ceka na 
         * uvolneni zamku.
         * 
         * Zamek se uvolni (odemkne) ve chvili, kdy vlakno opusti blok lock, takze
         * druhe vlakno do vstoupit do sveho bloku lock.
         */

        private static object consoleAccessLock = new object();

        static void Main(string[] args)
        {
            Thread xThread = new Thread(WriteYellowX);
            Thread oThread = new Thread(WriteRedO);

            xThread.Start();
            oThread.Start();
        }

        private static void WriteYellowX()
        {
            for (int i = 0; i < 1000; i++)
            {
                lock (consoleAccessLock)
                {
                    Console.ForegroundColor = ConsoleColor.Yellow;
                    Console.Write("X");
                }
            }
        }

        private static void WriteRedO()
        {
            for (int i = 0; i < 1000; i++)
            {
                lock (consoleAccessLock)
                {
                    Console.ForegroundColor = ConsoleColor.Red;
                    Console.Write("O");
                }
            }
        }
    }
}
